<template>
  <div class="buy-heta">
    <div class="content">
      <div class="list-coin">
        <div class="coin-item" v-for="(coin, index) in listCoin" @click="selectCoin(index)" :class="{ 'active': isCurrentCoin(coin) }">
          <img :src="coin.srcImg" :alt="coin.fullname" class="coin__image">
          <span class="coin__name">{{ coin.name }}</span>
        </div>
      </div>

      <template v-if="currentWallet && currentSetting && prices">
        <div class="btc-box">
          <div class="exchange-rate-group">
            <div class="content-left">
              <div class="textbox">
                <span class="number">1</span>
                <span class="text">{{ currentCoin | uppercase }}</span>
                <span class="equal">&asymp;</span>
                <span class="number">{{ currencyToUsdPrice }}</span>
                <span class="text">USD</span>
              </div>
            </div>

            <div class="content-right">
              <div class="textbox">
                <span class="number">1</span>
                <span class="text">HETA Token</span>
                <span class="equal">&asymp;</span>
                <span class="number">{{ tokenToCurrencyPrice }}</span>
                <span class="text">{{ currentCoin | uppercase }}</span>
              </div>
            </div>
          </div>

          <div class="buy-heta__input-wrapper">
            <currency-input
              type="text"
              v-model="currencyValue"
              name='currency_amount'
              data-vv-as="currency amount"
              v-validate="currencyValidator"
              data-vv-validate-on="none"
              :disabled="!isAvailable"
              :precision="currentSetting ? currentSetting.currency_precision : 0"
              :placeholder="$t('dashboard.buy.enter_amount')"
              @focus="onFocusCurrency"
              @blur="onBlurCurrency"
              class="buy-heta__input"/>
            <span class="unit">{{ currentCoin | uppercase }}</span>
          </div>
          <span class="invalid-feedback" v-if="errors.has('currency_amount')">{{ errors.first('currency_amount') }}</span>

          <div class="exchange-rate-group mb-8">
            <div class="content-left">
              <div class="textbox">
                <span class="iconmo-wallet"></span>
                <span class="number fz-medium">{{ currentWallet.available_balance | formatCurrencyAmount(currentCoin, 0) }}</span>
                <span class="text">{{ currentCoin | uppercase }}</span>
              </div>
            </div>

            <div class="content-right">
              <div class="btn-group">
                <span
                  class="btn-item"
                  v-for="(suggestion, index) in suggestedPercents"
                  :class="{ active: isCurrentSuggestion(index), disabled: !(isAvailable && isssetBalance) }"
                  @click="setCurrencyInput(index)">
                    {{ suggestion * 100 }}%
                </span>
              </div>
            </div>
          </div>

          <div class="buy-heta__input-wrapper">
            <currency-input
              type="text"
              v-model="tokenValue"
              name='token_amount'
              data-vv-as="token amount"
              v-validate="tokenValidator"
              data-vv-validate-on="none"
              :disabled="!isAvailable"
              :precision="currentSetting ? currentSetting.token_precision : 0"
              :placeholder="$t('dashboard.buy.enter_amount')"
              @focus="onFocusToken"
              @blur="onBlurToken"
              class="buy-heta__input"/>
            <span class="unit">HETA Token</span>
          </div>
          <span class="invalid-feedback" v-if="errors.has('token_amount')">{{ errors.first('token_amount') }}</span>

          <div class="expression" v-if="currentBonus && tokenValue > 0">
            <div class="item">
              <span class="number">{{ tokenValue | formatCurrencyAmount('heta', 0) }}</span>
              <span class="text">Token </span>
            </div>
            <div class="item">
              <span class="text"> + </span>
              <span class="number">{{ bonusValue }}</span>
              <span class="text">{{ $t('dashboard.buy.bonus') }}</span>
            </div>
            <div class="item block">
              <span class="text">= </span>
              <span class="number">{{ finalCurrencyValue }}</span>
              <span class="text">HETA Token</span>
            </div>
          </div>
        </div>

        <div class="buy-btn-wrapper">
          <span class="buy-btn" :class="{ disabled: !isAvailable }" @click="buyToken">{{ $t('dashboard.buy.btn') }}</span>
        </div>
      </template>
    </div>
  </div>
</template>
<script>
  import BuyToken from '../../../home/components/Dashboard/BuyToken.vue';
  import BuyTokenConfirmModal from '../Modal/BuyTokenConfirmModal.vue'
  export default {
    extends: BuyToken,
    methods: {
      openConfirmingModal() {
        const callback = this.executeBuyToken.bind(this);
        const currency = this.currentCoin;
        const token_amount = this.tokenValue;
        this.$broadcast('open-modal', BuyTokenConfirmModal, { callback, currency, token_amount });
      },
    },
  }
</script>
<style lang="scss" scoped>
  @import '../../../../sass/mobile/variables';
  @import '../../../../sass/mobile/vendor/position';

  .buy-heta {
    background-color: $bg_thin_gray;
    box-shadow: 0 0 70rem 0 rgba(0, 0, 0, 0.6);
    padding-bottom: 22rem;
    position: relative;
    z-index: 10;
  }

  .list-coin {
    text-align: center;
    margin-bottom: 12rem;
    font-size: 0;

    .coin-item {
      width: 33.33%;
      padding: 11rem 1rem;
      text-align: center;
      display: inline-block;
      background-color: #e3e3e3;
      &:not(:last-child) {
        border-right: 1rem solid #fff;
      }

      &.active {
        background-color: $dark_orange;
        .coin__name {
          color: $white;
        }
      }
    }

    .coin__image {
      margin-right: 10rem;
      width: 20rem;
      height: 20rem;
      vertical-align: middle;
    }

    .coin__name {
      vertical-align: middle;
      text-transform: uppercase;
      color: $black;
      font-size: $small;
      font-weight: bold;
    }
  }

  .exchange-rate-group {
    margin-bottom: 13rem;
    padding: 0 30rem;
    text-align: center;

    &:after {
      content: '';
      display: table;
      clear: both;
    }
  }

  .buy-heta__input-wrapper {
    position: relative;
    margin-bottom: 6rem;
    padding: 0 12px;

    .buy-heta__input {
      width: 100%;
      opacity: 0.5;
      border-radius: 70rem;
      background-color: $white;
      border: solid 1rem #b0b0b0;
      transition: all 0.3s ease-in-out;
      padding: 10rem 80rem 10rem 35rem;
      color: #333;
      font-size: $small;


      &:focus {
        border-color: #888;
        opacity: 1;
        outline: none;
      }

      &::placeholder {
        font-size: $small;
        color: #cacaca;
      }
    }

    .unit {
      @include absolute(50%, 35rem);
      color: $black;
      font-weight: bold;
      font-size: $small;
      transform: translateY(-50%);
    }
  }

  .btn-group {
    margin-top: 5px;
    .btn-item {
      font-size: $tiny;
      border-radius: 30rem;
      border: solid 1rem #d2d1d1;
      text-align: center;
      width: 50rem;
      display: inline-block;
      padding: 2rem 5rem;
      transition: all 0.3s ease-in-out;

      &:not(:last-child) {
        margin-right: 5rem;
      }

      &.active {
        background-color: #b0b0b0;
        color: #fff;
      }
    }
  }

  .buy-btn {
    display: block;
    text-transform: uppercase;
    width: 130rem;
    height: 40rem;
    margin: 0 auto;
    font-size: $tiny;
    font-weight: bold;
    line-height: 40rem;
    letter-spacing: 0.5rem;
    border-radius: 30rem;
    text-align: center;
    color: $white;
    cursor: pointer;
    transition: all 0.3s ease-in-out;
    border: solid 1rem #fa7300;
    background: #fa7300;
    &.active,
    &:hover {
      background-color: #da6400;
    }
    &.disabled {
      cursor: not-allowed;
      opacity: .65;
      &:hover{
        opacity: .65;
        background-color: #fa7300;
      }
    }
  }

  .buy-btn-wrapper {
    text-align: center;
    margin-top: 13rem;
  }

  .textbox,
  .expression {
    text-align: center;
    .number {
      font-size: $small;
      font-weight: bold;
      color: $black;
      margin-right: 5rem;
    }

    .text {
      font-size: $small;
      color: $gray;
    }

    .equal {
      font-size: $small;
      color: $gray;
      padding: 0 7rem;
    }
  }

  .expression {
    padding: 0 12px;
    font-size: $small;
    text-align: center;

    .item {
      display: inline-block;

      &.block {
        display: block;
      }
    }
  }

  .fz-medium {
    font-size: $medium !important;
  }

  .mb-8 {
    margin-bottom: 8rem !important;
  }

  .iconmo-wallet {
    font-size: $tiny;
    margin-right: 5rem;
  }
  .invalid-feedback {
    color: red;
    font-size: 13rem;
    text-align: center;
    padding-bottom: 10rem;
  }
  .disabled {
    cursor: not-allowed !important;
    opacity: .65 !important;
  }
</style>
